using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.PointOfService;

namespace MSR1
{
    public partial class Form1 : Form
    {

        private PosExplorer myExplorer;
        private Msr myMSR;
        
        public Form1()
        {
            InitializeComponent();
            myExplorer = new PosExplorer(this);

            DeviceInfo device = myExplorer.GetDevice("Msr", "myMSR1");
 

            myMSR = (Msr)myExplorer.CreateInstance(device);
            myMSR.Open();
            myMSR.Claim(1000);
            myMSR.DeviceEnabled = true;
            myMSR.DataEventEnabled = true;
            myMSR.DecodeData = true;
           


            myExplorer.DeviceAddedEvent += new DeviceChangedEventHandler(myExplorer_DeviceAddedEvent);
            myExplorer.DeviceRemovedEvent += new DeviceChangedEventHandler(myExplorer_DeviceRemovedEvent);



            
        }

        void myExplorer_DeviceRemovedEvent(object sender, DeviceChangedEventArgs e)
        {
            if (e.Device.Type == "Msr")
            {
                myMSR.DataEventEnabled = false;
                myMSR.Close();
                lblStatus.Text = "New Msr removed";

            }
        }



        void myExplorer_DeviceAddedEvent(object sender, DeviceChangedEventArgs e)
        {
            
            if(e.Device.Type == "Msr"){
                      
                myMSR = (Msr) myExplorer.CreateInstance(e.Device);
                lblStatus.Text = "New Msr attached: " + e.Device.ServiceObjectName;

                myMSR.Open();
                myMSR.Claim(1000);
                myMSR.DeviceEnabled = true;
                myMSR.DataEventEnabled = true;
                myMSR.DecodeData = true;

                Update();
                myMSR.DataEvent +=new DataEventHandler(myMSR_DataEvent);
            }
                       

        }

        void myMSR_DataEvent(object sender, DataEventArgs e)
        {
            ASCIIEncoding myEncoding = new ASCIIEncoding();

            txtInput.Text = myEncoding.GetString(myMSR.Track2Data);
            lblStatus.Text = "Data Event";
            Update();
            myMSR.DataEventEnabled = true;

        }



    }
}